#include <iostream>
#include <vector>
#include <map>
#include <cstring>
#include <cmath>
#include <fstream>

using namespace std;

vector<int> prime;
vector<int> elemente, elementeTry;
map<int, int> pasi, pasiTry, noDuplicates;


int nrWiningMovesTot, nrWiningMovesAlice;
int isAliceWinning = 0;


void makeMove(int nrImp, vector<int> &modif);
void undoMove(int nrImp, vector<int> &modif);
void actualizare(int prime, int &coef);
int ridicarePut(int x, int nr) {

    if(nr == 0) return 1;
    if(nr == 1) return x;
    if(nr % 2 == 0) return ridicarePut(x * x, nr / 2);
    return x * ridicarePut(x * x, (nr - 1) / 2);
}

int bkt(int poz) // 1 Alice, 2 Bob
{
    int ok = 0;
    for(auto i: elemente) {
        if(i != 1) {
            ok = 1;
            break;
        }
    }
    if(ok == 0) {
        return 0;
    }
    else {
        int isWinning = 0;
        for(auto& mutare: pasi) {


            for(int i = mutare.second; i >= 1; i--) {

                int nrImp = ridicarePut(mutare.first, i);

                vector<int> modif;
                makeMove(nrImp, modif);
                int previous = mutare.second;

                actualizare(mutare.first, mutare.second);
                int ok = bkt(poz + 1);
                undoMove(nrImp, modif);
                mutare.second = previous;
                if(ok == 0) {
                    isWinning = 1;
                    if(poz == 1) {
                        nrWiningMovesAlice++;
                        isAliceWinning = 1;
                    }
                    else break;
                }
                else if(poz == 1) nrWiningMovesTot++;
            }
        }
        return isWinning;
    }

}

void actualizare(int prime, int &coef)
{
    int best = 0;
    for(int x = 0; x < elemente.size(); x++) {
        int curent = 0;
        int elementCurent = elemente[x];
        while(elementCurent % prime == 0) {
            curent++;
            elementCurent /= prime;
        }
        if(curent > best) best = curent;
    }
    coef = best;
}

void makeMove(int nrImp, vector<int> &modif)
{
    for(int x = 0; x < elemente.size(); x++) {
        if(elemente[x] % nrImp == 0) {
            elemente[x] /= nrImp;
            modif.push_back(x);
        }
    }
}

void undoMove(int nrImp, vector<int> &modif)
{
    for(auto x : modif) {
        elemente[x] *= nrImp;
    }
}

int valid(int element) {
    for (auto k: prime) {
        if(element == 1) break;
        int exp = 0;
        while (element % k == 0) {
            element /= k;
            exp++;
        }
        if (exp > 0) {
            if(pasi[k] == exp) {
                return 1;
            }
        }
    }
    return 0;
}

int main() {
    ifstream cin("game.in");
    ofstream cout("game.out");

    int ciur[1001];
    memset(ciur, 0, sizeof(ciur));
    prime.push_back(2);
    for(int x = 3; x <= 1000; x+=2)
    {
        if(ciur[x] == 0) prime.push_back(x);
        for(int y = x*2; y <= 1000; y+=x)
            ciur[y] = 1;
    }

    int t, c;
    cin >> t >> c;

    for(int i = 0; i < t; i++) {

        isAliceWinning = 0;
        nrWiningMovesAlice = 0;
        nrWiningMovesTot = 0;
        elementeTry.clear();
        elemente.clear();
        pasiTry.clear();
        pasi.clear();
        noDuplicates.clear();

        int nr;
        cin >> nr;

        for (int j = 0; j < nr; j++) {
            int x;
            cin >> x;
            if (noDuplicates[x] == 0) {
                noDuplicates[x] = 1;
                elementeTry.push_back(x);
                for (auto k: prime) {
                    int exp = 0;
                    while (x % k == 0) {
                        x /= k;
                        exp++;
                    }
                    if (exp > 0) {
                        pasiTry[k] = max(pasiTry[k], exp);
                    }
                }
            }
        }

        int coef = 0;
        map<int, int>::iterator it;

        for(it = pasiTry.begin(); it != pasiTry.end(); it++) {
                pasi[it->first] = it->second;
        }

        vector<int>::iterator itVector;
        for(itVector = elementeTry.begin(); itVector != elementeTry.end(); itVector++) {
            if(valid(*itVector)) elemente.push_back(*itVector);
        }



        bkt(1);

        if(c == 1) {
            if(coef == 0) {
                if (isAliceWinning == 1) cout << "Alice" << '\n';
                else cout << "Bob" << '\n';
            }
            else {
                if (isAliceWinning == 1) cout << "Bob" << '\n';
                else cout << "Alice" << '\n';
            }
        }
        else {
            if(coef == 0) {
                if (isAliceWinning == 1) cout << nrWiningMovesAlice << '\n';
                else cout << nrWiningMovesTot << '\n';
            }
            else {
                if (isAliceWinning == 1) cout << nrWiningMovesTot << '\n';
                else cout << nrWiningMovesAlice << '\n';
            }
        }

    }
    return 0;
}