#include <fstream>
#include <vector>
#include <cstring>
using namespace std;
#define all(v) v.begin(), v.end()
#define VMAX 1100010
#define SIZE 10010
#define NMAX 100010

bool isPrime[VMAX];
int mex[VMAX], bits[VMAX];
vector<int> primes;
int v[NMAX];

int move(int cfg, int k)
{
	if(cfg == -1) return -1;
	if((1 << k) > cfg) return -1;

	cfg = (cfg >> k) | (cfg & ((1 << k) - 1));
	if(cfg & 1) cfg ^= 1;

	return cfg;
}

void sieve(int n)
{
	int i, j;

	for(i = 3; i <= n; i += 2) isPrime[i] = true;

	isPrime[2] = true;
	primes.push_back(2);
	for(i = 3; i <= n; i += 2)
	{
		if(!isPrime[i]) continue;
		primes.push_back(i);

		if(i > 10000) continue;
		for(j = i * i; j <= n; j += i + i) isPrime[j] = false;
	}
}

void build_cfgs(int n)
{
	memset(bits, 0, sizeof bits);

	int e;
	for(int i = 0; i < n; ++i)
	{
		for(auto it = primes.begin(); it != primes.end() && (*it) * (*it) <= v[i]; ++it)
		{
			for(e = 0; v[i] % (*it) == 0; ++e, v[i] /= (*it));
			if(e > 0) bits[*it] |= (1 << e);
		}

		if(v[i] != 1) bits[v[i]] |= 2;
	}
}

void dp_mex(int n)
{
	int i, j, x;
	bool vmex[25];

	for(i = 2; i <= n; i += 2)
	{
		memset(vmex, 0, sizeof vmex);
		for(j = 1; (1 << j) <= i; ++j)
		{
			x = move(i, j);
			vmex[mex[x]] = true;
		}

		for(j = 0; vmex[j]; ++j);
		mex[i] = j;
	}
}

int solve1(int cfg)
{
	int i, j, x, nr;

	for(nr = 0, i = 1; i < VMAX; ++i)
	{
		if(!isPrime[i]) continue;

		for(j = 1; (1 << j) <= bits[i]; ++j)
		{
			x = move(bits[i], j);
			if((cfg ^ mex[bits[i]] ^ mex[x]) == 0)
			{
				++nr;
				//cerr << i << ' ' << j << '\n';
			}
		}
	}

	return nr;
}

int solve2(int cfg)
{
	int i, j, p1, p2, k1, k2, nr, newCfg, newMex;
	bool stop, ok;

	for(nr = 0, i = 0; i < primes.size(); ++i)
	{
		p1 = primes[i];
		for(k1 = 1; (1 << k1) <= bits[p1]; ++k1)
		{
			// Bob chooses p1 ^ k1
			/*if(p1 == 3 && k1 == 2) ok = true;
			else ok = false;*/

			stop = false;
			for(j = 0; j < primes.size() && !stop; ++j)
			{
				p2 = primes[j];
				for(k2 = 1; (1 << k2) <= bits[p2] && !stop; ++k2)
				{
					// Alice chooses p2 ^ k2
					if(p1 == p2)
					{
						newCfg = move(bits[p2], k2);
						newCfg = move(newCfg, k1);
						if(newCfg == -1) continue;

						newMex = mex[cfg] ^ mex[bits[p2]] ^ mex[newCfg];
						if(newMex == 0) ++nr, stop = true;
					}
					else
					{
						newMex = mex[cfg] ^ mex[bits[p1]] ^ mex[move(bits[p1], k1)];
						newMex ^= mex[bits[p2]] ^ mex[move(bits[p2], k2)];
						//if(ok && p2 == 11 && k2 == 1) cerr << "mex = " << newMex << '\n';
						if(newMex == 0) ++nr, stop = true;
					}
				}
			}

			//f(stop) cerr << p1 << ' ' << k1 << '\n';
		}
	}

	return nr;
}

int main()
{
	ifstream fin("game.in");
	ofstream fout("game.out");

	int i, t, c, n, cfg, winner;

	sieve(VMAX - 1);
	dp_mex(VMAX - 1);

	fin >> t >> c;

	while(t--)
	{
		fin >> n;
		for(i = 0; i < n; ++i) fin >> v[i];

		build_cfgs(n);

		for(cfg = 0, i = 1; i < VMAX; ++i)
			cfg ^= mex[bits[i]];

		winner = (cfg != 0);

		if(c == 1)
		{
			fout << (winner ? "Alice\n" : "Bob\n");
		}
		else
		{
			if(winner)
			{
				fout << solve1(cfg) << '\n';
			}
			else
			{
				fout << solve2(cfg) << '\n';
			}
		}
	}

	/*for(i = 1; i < VMAX; ++i)
		if(bits[i])
			cerr << bits[i] << ' ';*/

	//for(i = 1; i <= 20; ++i) cerr << mex[i] << ' ';

	return 0;
}
